#!/usr/bin/perl -w

# ========================================================================
#        NC201-210  #
#=========================================================================
#  8  2022              .   pashigorov.e  gmail.com
#
#   SVARS  

if ($#ARGV < 1) {
    die "\n Usage:  $0  <var_file> <logic_file>\n";
}

#     
open FIN, $ARGV[0] or die "cannot open $ARGV[0]";
#_______________________________________________
#    
#    
#_______________________________________________

%symvar = ();
foreach $line (<FIN>) {
    if ( $line =~ m/^(\w+)\s*=\s*([KIUW]\d{1,3}[KNA]\d\d?)/ ) {
        $svar = "!" . "$1";
        $ind = $2;
        #    
        if ( $ind =~ m/([KIUW])0?(\d[KNA]\d\d?)/ ) {
            $ind =  "$1" . "0?";
            $ind = "$ind" . "$2";
        }
        #     ( )
        $ind = "$ind" . "\\b";
        #printf "$ind --> $svar\n";
        $symvar{$ind} = $svar; 
    }       
}
close FIN;

#_____________________________________________________
#     ()
#   -   
#______________________________________________________

open FIN, $ARGV[1] or die "cannot open $ARGV[0]";
printf ";/////////////// original file $ARGV[1] /////////////////\n\n";

foreach $line (<FIN>) {
    # 
    if ($line !~ m/^.*;.*/) {
        while ( ($pattern, $replace) = each(%symvar) ) {
            $line =~ s/$pattern/$replace/g;
        }
        #     
        $line =~ s/([\+\*\-\=])/ $1 /g;
        $line =~ s/,/, /g;
        $line =~ s/ +/ /g;
    }
    printf "$line"
}
close FIN;







